# Class FileImageInputStream

java.lang.Object
javax.imageio.stream.ImageInputStreamImpl
javax.imageio.stream.FileImageInputStream

All Implemented Interfaces:
  `Closeable, DataInput, AutoCloseable, ImageInputStream`

public class FileImageInputStream extends ImageInputStreamImpl
An implementation of `ImageInputStream` that gets its input from a `File` or `RandomAccessFile`. The file contents are assumed to be stable during the lifetime of the object.

## Field Summary

### Fields declared in class ImageInputStreamImpl

`bitOffset, byteOrder, flushedPos, streamPos`
Modifier and Type
Field
Description
`protected int`
`bitOffset`
The current bit offset within the stream.
`protected ByteOrder`
`byteOrder`
The byte order of the stream as an instance of the enumeration class `java.nio.ByteOrder`, where `ByteOrder.BIG_ENDIAN` indicates network byte order and `ByteOrder.LITTLE_ENDIAN` indicates the reverse order.
`protected long`
`flushedPos`
The position prior to which data may be discarded.
`protected long`
`streamPos`
The current read position within the stream.

## Constructor Summary

Constructors
Constructor
Description
`FileImageInputStream(File f)`
Constructs a `FileImageInputStream` that will read from a given `File`.
`FileImageInputStream(RandomAccessFile raf)`
Constructs a `FileImageInputStream` that will read from a given `RandomAccessFile`.

## Method Summary

Modifier and Type
Method
Description
`long`
`length()`
Returns the length of the underlying file, or `-1` if it is unknown.
`int`
`read()`
Reads a single byte from the stream and returns it as an `int` between 0 and 255.
`int`
`read(byte[] b, int off, int len)`
Reads up to `len` bytes from the stream, and stores them into `b` starting at index `off`.

### Methods declared in class ImageInputStreamImpl

`checkClosed, close, flush, flushBefore, getBitOffset, getByteOrder, getFlushedPosition, getStreamPosition, isCached, isCachedFile, isCachedMemory, mark, read, readBit, readBits, readBoolean, readByte, readBytes, readChar, readDouble, readFloat, readFully, readFully, readFully, readFully, readFully, readFully, readFully, readFully, readInt, readLine, readLong, readShort, readUnsignedByte, readUnsignedInt, readUnsignedShort, readUTF, reset, seek, setBitOffset, setByteOrder, skipBytes, skipBytes`
Modifier and Type
Method
Description
`protected final void`
`checkClosed()`
Throws an `IOException` if the stream has been closed.
`void`
`close()`
Closes the stream.
`void`
`flush()`
Discards the initial position of the stream prior to the current stream position.
`void`
`flushBefore(long pos)`
Discards the initial portion of the stream prior to the indicated position.
`int`
`getBitOffset()`
Returns the current bit offset, as an integer between 0 and 7, inclusive.
`ByteOrder`
`getByteOrder()`
Returns the byte order with which data values will be read from this stream as an instance of the `java.nio.ByteOrder` enumeration.
`long`
`getFlushedPosition()`
Returns the earliest position in the stream to which seeking may be performed.
`long`
`getStreamPosition()`
Returns the current byte position of the stream.
`boolean`
`isCached()`
Default implementation returns false.
`boolean`
`isCachedFile()`
Default implementation returns false.
`boolean`
`isCachedMemory()`
Default implementation returns false.
`void`
`mark()`
Pushes the current stream position onto a stack of marked positions.
`int`
`read(byte[] b)`
A convenience method that calls `read(b, 0, b.length)`.
`int`
`readBit()`
Reads a single bit from the stream and returns it as an `int` with the value `0` or `1`.
`long`
`readBits(int numBits)`
Reads a bitstring from the stream and returns it as a `long`, with the first bit read becoming the most significant bit of the output.
`boolean`
`readBoolean()`
Reads a byte from the stream and returns a `boolean` value of `true` if it is nonzero, `false` if it is zero.
`byte`
`readByte()`
Reads a byte from the stream and returns it as a `byte` value.
`void`
`readBytes(IIOByteBuffer buf, int len)`
Reads up to `len` bytes from the stream, and modifies the supplied `IIOByteBuffer` to indicate the byte array, offset, and length where the data may be found.
`char`
`readChar()`
Equivalent to `readUnsignedShort`, except that the result is returned using the `char` datatype.
`double`
`readDouble()`
Reads 8 bytes from the stream, and (conceptually) concatenates them according to the current byte order and returns the result as a `double`.
`float`
`readFloat()`
Reads 4 bytes from the stream, and (conceptually) concatenates them according to the current byte order and returns the result as a `float`.
`void`
`readFully(byte[] b)`
Reads `b.length` bytes from the stream, and stores them into `b` starting at index `0`.
`void`
`readFully(byte[] b, int off, int len)`
Reads `len` bytes from the stream, and stores them into `b` starting at index `off`.
`void`
`readFully(char[] c, int off, int len)`
Reads `len` chars (unsigned 16-bit integers) from the stream according to the current byte order, and stores them into `c` starting at index `off`.
`void`
`readFully(double[] d, int off, int len)`
Reads `len` doubles (64-bit IEEE double-precision floats) from the stream according to the current byte order, and stores them into `d` starting at index `off`.
`void`
`readFully(float[] f, int off, int len)`
Reads `len` floats (32-bit IEEE single-precision floats) from the stream according to the current byte order, and stores them into `f` starting at index `off`.
`void`
`readFully(int[] i, int off, int len)`
Reads `len` ints (signed 32-bit integers) from the stream according to the current byte order, and stores them into `i` starting at index `off`.
`void`
`readFully(long[] l, int off, int len)`
Reads `len` longs (signed 64-bit integers) from the stream according to the current byte order, and stores them into `l` starting at index `off`.
`void`
`readFully(short[] s, int off, int len)`
Reads `len` shorts (signed 16-bit integers) from the stream according to the current byte order, and stores them into `s` starting at index `off`.
`int`
`readInt()`
Reads 4 bytes from the stream, and (conceptually) concatenates them according to the current byte order and returns the result as an `int`.
`String`
`readLine()`
Reads the next line of text from the input stream.
`long`
`readLong()`
Reads 8 bytes from the stream, and (conceptually) concatenates them according to the current byte order and returns the result as a `long`.
`short`
`readShort()`
Reads two bytes from the stream, and (conceptually) concatenates them according to the current byte order, and returns the result as a `short` value.
`int`
`readUnsignedByte()`
Reads a byte from the stream, and (conceptually) converts it to an int, masks it with `0xff` in order to strip off any sign-extension bits, and returns it as a `byte` value.
`long`
`readUnsignedInt()`
Reads 4 bytes from the stream, and (conceptually) concatenates them according to the current byte order, converts the result to a long, masks it with `0xffffffffL` in order to strip off any sign-extension bits, and returns the result as an unsigned `long` value.
`int`
`readUnsignedShort()`
Reads two bytes from the stream, and (conceptually) concatenates them according to the current byte order, converts the resulting value to an `int`, masks it with `0xffff` in order to strip off any sign-extension buts, and returns the result as an unsigned `int` value.
`String`
`readUTF()`
Reads in a string that has been encoded using a modified UTF-8 format.
`void`
`reset()`
Resets the current stream byte and bit positions from the stack of marked positions.
`void`
`seek(long pos)`
Sets the current stream position to the desired location.
`void`
`setBitOffset(int bitOffset)`
Sets the bit offset to an integer between 0 and 7, inclusive.
`void`
`setByteOrder(ByteOrder byteOrder)`
Sets the desired byte order for future reads of data values from this stream.
`int`
`skipBytes(int n)`
Advances the current stream position by calling `seek(getStreamPosition() + n)`.
`long`
`skipBytes(long n)`
Advances the current stream position by calling `seek(getStreamPosition() + n)`.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`String`
`toString()`
Returns a string representation of the object.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Constructor Details

### FileImageInputStream

public FileImageInputStream(File f) throws FileNotFoundException, IOException
Constructs a `FileImageInputStream` that will read from a given `File`.

The file contents must not change between the time this object is constructed and the time of the last call to a read method.

Parameters:
  `f` - a `File` to read from.
Throws:
  `IllegalArgumentException` - if `f` is `null`.
  `FileNotFoundException` - if `f` is a directory or cannot be opened for reading for any other reason.
  `IOException` - if an I/O error occurs.

### FileImageInputStream

public FileImageInputStream(RandomAccessFile raf)
Constructs a `FileImageInputStream` that will read from a given `RandomAccessFile`.

The file contents must not change between the time this object is constructed and the time of the last call to a read method.

Parameters:
  `raf` - a `RandomAccessFile` to read from.
Throws:
  `IllegalArgumentException` - if `raf` is `null`.

## Method Details

### read

public int read() throws IOException
Description copied from class: `ImageInputStreamImpl`
Reads a single byte from the stream and returns it as an `int` between 0 and 255. If EOF is reached, `-1` is returned.

Subclasses must provide an implementation for this method. The subclass implementation should update the stream position before exiting.

The bit offset within the stream must be reset to zero before the read occurs.

Specified by:
  `read` in interface `ImageInputStream`
Specified by:
  `read` in class `ImageInputStreamImpl`
Returns:
  the value of the next byte in the stream, or `-1` if EOF is reached.
Throws:
  `IOException` - if the stream has been closed.

### read

public int read(byte[] b, int off, int len) throws IOException
Description copied from class: `ImageInputStreamImpl`
Reads up to `len` bytes from the stream, and stores them into `b` starting at index `off`. If no bytes can be read because the end of the stream has been reached, `-1` is returned.

The bit offset within the stream must be reset to zero before the read occurs.

Subclasses must provide an implementation for this method. The subclass implementation should update the stream position before exiting.

Specified by:
  `read` in interface `ImageInputStream`
Specified by:
  `read` in class `ImageInputStreamImpl`
Parameters:
  `b` - an array of bytes to be written to.
  `off` - the starting position within `b` to write to.
  `len` - the maximum number of bytes to read.
Returns:
  the number of bytes actually read, or `-1` to indicate EOF.
Throws:
  `IOException` - if an I/O error occurs.

### length

public long length()
Returns the length of the underlying file, or `-1` if it is unknown.

Specified by:
  `length` in interface `ImageInputStream`
Overrides:
  `length` in class `ImageInputStreamImpl`
Returns:
  the file length as a `long`, or `-1`.